/*
 *   WDX: WitchDoctor-WDX, versatile distributed lock manager
 *   Copyright (C) 2003 Dominique Chabord,
 *   Please refer to credits section below
 *
 *
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *   ************************************************
 *
 *   History and credits:
 *   First version of WitchDoctor-WDX was based on:
 *
 *   DECwatchdog/Autopilot, watchdog and lock manager
 *   Copyright (C) 2003 HP
 *
 *   Developed by
 *     Computer Special Systems, Annecy France
 *     A Division of Digital Equipment Corporation
 *   and
 *     Custom-Systems, Annecy France
 *     An engineering center of Compaq
 *
 *   Provided under GNU-GPL terms by HP, 30 June 2003
 *   GNU-GPL replaces previous license statements
 *
 *   Rebranded, ported and modified for Shaman-X project, 15 July 2003
 *   by Dominique Chabord
 *   and maintained by other contributors as mentionned in the code
 *
 *   ************************************************
 *
 *   WDX is promoted by Shaman-X project
 *
 *   Check for new versions and documentation at
 *   http://www.shaman-x.org
 *
 *   ************************************************
 *
 *   Most of WDX code is designed to run unchanged on
 *   different operating systems, including at V1.0 time:
 *   Gnu-Linux, WindowsNT, DigitalUNIX and OpenVMS.
 *   Operating system specifics are identified by dedicated files.
 *
 *   Evolutions
 *   ----------
 *   July-2003     Dominique Chabord    WitchDoctor-WDX V1.0
 *                 Creation
 *
 *   ************************************************
 *
 *
 *	wdx_config.h	 
 *
 *	Configuration file definitions
 *
 ************************************************************************/
/*
 *
 *  11-Feb-94 -- Cornu
 *      Creation
 */

#ifndef		WDX_CONFIG
#define		WDX_CONFIG


/*
 * CONFIGURATION FILE definitions
 */

/* local file */
#define LOCAL_COUNT_WORDS 2		/* number of words for local lines */

#define MAX_SCRIPT_INDEX              8 /* MULTIPLE of int size : conf_checksum() */
#define NOSUBSTITUTESCRIPT_INDEX      0
#define NEWMASTERSCRIPT_INDEX         1
#define SATELLITESCRIPT_INDEX         2
#define EXCEPTIONSCRIPT_INDEX         3
#define EVENTSCRIPT_INDEX             4
#define OBSERVERSCRIPT_INDEX          5

#define MASTER_STRING                 "NOSUBSTITUTESCRIPT"
#define EVENT_STRING                  "EVENTSCRIPT"
#define SUBSTITUTE_STRING             "NEWMASTERSCRIPT"
#define SATELLITE_STRING              "SATELLITESCRIPT"
#define EXCEPTION_STRING              "EXCEPTIONSCRIPT"

#define NETWORK_UNKNOWN_TO_ON_STRING           "NETWORK_UNKNOWN_TO_ON"
#define NETWORK_UNKNOWN_TO_OFF_STRING          "NETWORK_UNKNOWN_TO_OFF"
#define NETWORK_ON_TO_OFF_STRING               "NETWORK_ON_TO_OFF"
#define NETWORK_ON_TO_UNKNOWN_STRING           "NETWORK_ON_TO_UNKNOWN"
#define NETWORK_OFF_TO_UNKNOWN_STRING          "NETWORK_OFF_TO_UNKNOWN"
#define NETWORK_OFF_TO_ON_STRING               "NETWORK_OFF_TO_ON"
#define MEMBER_FAULT_TO_IDLE_STRING            "MEMBER_FAULT_TO_IDLE"
#define MEMBER_FAULT_TO_MASTER_STRING          "MEMBER_FAULT_TO_MASTER"
#define MEMBER_FAULT_TO_SUBSTITUTE_STRING      "MEMBER_FAULT_TO_SUBSTITUTE"
#define MEMBER_FAULT_TO_SATELLITE_STRING       "MEMBER_FAULT_TO_SATELLITE"
#define MEMBER_IDLE_TO_FAULT_STRING            "MEMBER_IDLE_TO_FAULT"
#define MEMBER_IDLE_TO_MASTER_STRING           "MEMBER_IDLE_TO_MASTER"
#define MEMBER_IDLE_TO_SUBSTITUTE_STRING       "MEMBER_IDLE_TO_SUBSTITUTE"
#define MEMBER_IDLE_TO_SATELLITE_STRING        "MEMBER_IDLE_TO_SATELLITE"
#define MEMBER_MASTER_TO_FAULT_STRING          "MEMBER_MASTER_TO_FAULT"
#define MEMBER_MASTER_TO_IDLE_STRING           "MEMBER_MASTER_TO_IDLE"
#define MEMBER_MASTER_TO_SUBSTITUTE_STRING     "MEMBER_MASTER_TO_SUBSTITUTE"
#define MEMBER_MASTER_TO_SATELLITE_STRING      "MEMBER_MASTER_TO_SATELLITE"
#define MEMBER_SUBSTITUTE_TO_FAULT_STRING      "MEMBER_SUBSTITUTE_TO_FAULT"
#define MEMBER_SUBSTITUTE_TO_IDLE_STRING       "MEMBER_SUBSTITUTE_TO_IDLE"
#define MEMBER_SUBSTITUTE_TO_MASTER_STRING     "MEMBER_SUBSTITUTE_TO_MASTER"
#define MEMBER_SUBSTITUTE_TO_SATELLITE_STRING  "MEMBER_SUBSTITUTE_TO_SATELLITE"
#define MEMBER_SATELLITE_TO_FAULT_STRING       "MEMBER_SATELLITE_TO_FAULT"
#define MEMBER_SATELLITE_TO_IDLE_STRING        "MEMBER_SATELLITE_TO_IDLE"
#define MEMBER_SATELLITE_TO_MASTER_STRING      "MEMBER_SATELLITE_TO_MASTER"
#define MEMBER_SATELLITE_TO_SUBSTITUTE_STRING  "MEMBER_SATELLITE_TO_SUBSTITUTE"
#define RESOURCE_UNKNOWN_TO_UNKNOWN_STRING     "RESOURCE_UNKNOWN_TO_UNKNOWN"
#define RESOURCE_UNKNOWN_TO_FREE_STRING        "RESOURCE_UNKNOWN_TO_FREE"
#define RESOURCE_UNKNOWN_TO_RESERVED_STRING    "RESOURCE_UNKNOWN_TO_RESERVED"
#define RESOURCE_UNKNOWN_TO_MOUNTED_STRING     "RESOURCE_UNKNOWN_TO_MOUNTED"
#define RESOURCE_UNKNOWN_TO_FAULT_STRING       "RESOURCE_UNKNOWN_TO_FAULT"
#define RESOURCE_FREE_TO_UNKNOWN_STRING        "RESOURCE_FREE_TO_UNKNOWN"
#define RESOURCE_FREE_TO_FREE_STRING           "RESOURCE_FREE_TO_FREE"
#define RESOURCE_FREE_TO_RESERVED_STRING       "RESOURCE_FREE_TO_RESERVED"
#define RESOURCE_FREE_TO_MOUNTED_STRING        "RESOURCE_FREE_TO_MOUNTED"
#define RESOURCE_FREE_TO_FAULT_STRING          "RESOURCE_FREE_TO_FAULT"
#define RESOURCE_RESERVED_TO_UNKNOWN_STRING    "RESOURCE_RESERVED_TO_UNKNOWN"
#define RESOURCE_RESERVED_TO_FREE_STRING       "RESOURCE_RESERVED_TO_FREE"
#define RESOURCE_RESERVED_TO_RESERVED_STRING   "RESOURCE_RESERVED_TO_RESERVED"
#define RESOURCE_RESERVED_TO_MOUNTED_STRING    "RESOURCE_RESERVED_TO_MOUNTED"
#define RESOURCE_RESERVED_TO_FAULT_STRING      "RESOURCE_RESERVED_TO_FAULT"
#define RESOURCE_MOUNTED_TO_UNKNOWN_STRING     "RESOURCE_MOUNTED_TO_UNKNOWN"
#define RESOURCE_MOUNTED_TO_FREE_STRING        "RESOURCE_MOUNTED_TO_FREE"
#define RESOURCE_MOUNTED_TO_MOUNTED_STRING     "RESOURCE_MOUNTED_TO_MOUNTED"
#define RESOURCE_MOUNTED_TO_RESERVED_STRING    "RESOURCE_MOUNTED_TO_RESERVED"
#define RESOURCE_MOUNTED_TO_FAULT_STRING       "RESOURCE_MOUNTED_TO_FAULT"
#define RESOURCE_FAULT_TO_UNKNOWN_STRING       "RESOURCE_FAULT_TO_UNKNOWN"
#define RESOURCE_FAULT_TO_FREE_STRING          "RESOURCE_FAULT_TO_FREE"
#define RESOURCE_FAULT_TO_RESERVED_STRING      "RESOURCE_FAULT_TO_RESERVED"
#define RESOURCE_FAULT_TO_MOUNTED_STRING       "RESOURCE_FAULT_TO_MOUNTED"
#define RESOURCE_FAULT_TO_FAULT_STRING         "RESOURCE_FAULT_TO_FAULT"
#define MISMATCH_STRING			       "MISMATCH"

#define YES_STRING           "YES"
#define NO_STRING            "NO"

struct local_file {
char             script[MAX_SCRIPT_INDEX][SCRIPT_LEN];
struct mask_element	 networkmasks[NETWORK_STATUS][NETWORK_STATUS];
struct mask_element	 membermasks[MEMBER_STATUS][MEMBER_STATUS];
struct mask_element 	 resourcemasks[RESOURCE_STATUS][RESOURCE_STATUS];
struct mask_element	 mismatchmask;
};


/*
 * Support file 
 */
#define SUPPORT_COUNT_WORDS 2

#define THRESHOLD_COUNT_WORDS 2	    /* arguments of the threshold line */

#define LOG_FLAG_STRING "LOG_FLAG"
#define LOG_FILE_STRING "LOG_FILE"
#define PRIORITY_STRING "PRIORITY"
#define PERIOD_STRING "PERIOD"
#define ACTIVITY_STRING "ACTIVITY"
#define THRESHOLD_STRING "THRESHOLD"
#define STATISTICS_STRING "STATISTICS"

#define DISABLE_STRING "DISABLE"
#define ENABLE_STRING  "ENABLE"

struct threshold
{
int index;  /* index of the member in memberlist file */
int value;  /* threshold value */
};

struct support_file
{
enum flag  log;
char logfile[SCRIPT_LEN];
int  priority;
int  period;
enum flag activity;
struct threshold thresholdtable[MEMBER_COUNT];
int thresholdcount;
enum flag   statistics;
int  statisticsperiod;
};


/* 
 * mission file 
 */
#define MISSION_KEYWORD_COUNT 3

/* cfg file keywords */
#define MEMBER_STRING	"MEMBER"
#define DATE_STRING	"DATE"
#define VERSION_STRING	"VERSION"

#define DATE_COUNT 1	    /* number of date line required in cfg file */

#define VERSION_COUNT 1	    /* number of version line required in cfg file */
#define VERSION_HIGH_MIN 0  /* version field is in the range 0.0 to 1.9 */
#define VERSION_HIGH_MAX 1
#define VERSION_LOW_MIN 0
#define VERSION_LOW_MAX 9

#define MEMBER_COUNT_WORDS 8

#define MASTER_CANDIDATE_STRING           "MASTER/SUBSTITUTE"
#define SATELLITE_CANDIDATE_STRING        "SATELLITE"

#define NETWORK_NA      "N/A"


/* member definition structure */
struct member_def
{
    char          name[MEMBER_LEN];	/* internet name of machine	*/
    enum member_type          type;	/* Is this host master candidate ? */
    int			  priority;     /* mastertoken priority affectation */
    int                  broadcast;     /* config broadcast value */
    int                   validity;     /* config validity value */
    int                 redundancy;     /* redundancy value */
    char netname[NETWORKS][IFNAMSIZ];   /* interfaces characteristics */
};

/* encoded structure */
struct encoded_member_def
{
    WDX_BYTE            name[MEMBER_LEN]; /* internet name of machine	*/
    WDX_INT                         type; /* Is this host master candidate ? */
    WDX_INT		        priority; /* mastertoken priority affectation */
    WDX_INT                    broadcast; /* config broadcast value */
    WDX_INT                     validity; /* config validity value */
    WDX_INT                   redundancy; /* redundancy value */
    WDX_BYTE netname[NETWORKS][IFNAMSIZ]; /* interfaces characteristics */
};

/* mission_file is the image of the mission file */
struct mission_file {
unsigned char      version[VERSION_WORDS_COUNT];
char               date[DATE_LEN+1];
struct member_def  memberlist[MEMBER_COUNT];
};

/* encoded mission_file for mission file version calculation */
struct encoded_mission_file {
WDX_BYTE   version[VERSION_WORDS_COUNT];
WDX_BYTE   date[DATE_LEN+1];
struct encoded_member_def  memberlist[MEMBER_COUNT];
};


/*
 * Data declaration
 */
#ifdef WDX_CONFIG_MODULE

/* 
 * Function prototypes
 */
int version_line_analyze(char *s,struct mission_file *c,int *p);
int date_line_analyze(char *s,struct mission_file *c,int *p);
int member_line_analyze(char *s,struct mission_file *c,int *p);

int read_mission(char *filename,struct mission_file *c,int *countpt);
int read_local(char *filename,struct local_file  *c);
int read_support(char *filename,struct support_file *c,struct mission_file *d,int e);
int read_members_ip(char *filename);
int field_copy(char *r,int size,char *s); 
void encode_mission_file(struct mission_file *cp,struct encoded_mission_file *ecp);
void decode_mission_file(struct encoded_mission_file *ecp,struct mission_file     *cp);
int conf_checksum(struct mission_file *cfpt,unsigned int *cspt);
int unique_key(char *mission);
/*
 * Functions definition : in all these functions if -1 is returned then
 * the global variable messagestring is set with an error message.
 */
int version_funct(struct local_file *c,int i1,int i2,char *w,char *k);
int date_funct(struct local_file *c,int i1,int i2,char *w,char *k);
int script_funct(struct local_file *c,int i1,int i2,char *w,char *k);
int netmask_funct(struct local_file *c,int i1,int i2,char *w,char *k);
int membmask_funct(struct local_file *c,int i1,int i2,char *w,char *k);
int resmask_funct(struct local_file *c,int i1,int i2,char *w,char *k);
int mismask_funct(struct local_file *c,int i1,int i2,char *w,char *k);
int end_funct();

int name_funct(struct member_def *c,char *w);
int type_funct(struct member_def *c,char *w);
int priority_funct(struct member_def *c,char *w);
int broadcast_funct(struct member_def *c,char *w);
int validity_funct(struct member_def *c,char *w);
int redundancy_funct(struct member_def *c,char *w);
int network1_funct(struct member_def *c,char *w);
int network2_funct(struct member_def *c,char *w);

int logflag_funct(struct support_file *c,char *w,struct mission_file *d,int e);
int logfile_funct(struct support_file *c,char *w,struct mission_file *d,int e);
int period_funct(struct support_file *c,char *w,struct mission_file *d,int e);
int os_priority_funct(struct support_file *c,char *w,struct mission_file *d,int e);
int activity_funct(struct support_file *c,char *w,struct mission_file *d,int e);
int threshold_funct(struct support_file *c,char *w,struct mission_file *d,int e);
int statistics_funct(struct support_file *c,char *w,struct mission_file *d,int e);

/*
 * Local structures
 */
 
/* File analyze structure */
struct file_analyze
{
    char	  *keyword; /* keyword */
    int         (*funct)(); /* function */
    int               *cpt; /* counter to number of identical lines read */
};

#define VERSION_ELEMENT 0 /* index of version analyze in next structure */
#define DATE_ELEMENT    1 /* index of date analyze in next structure */
#define MEMBER_ELEMENT  2 /* index of member analyze in next structure */

struct file_analyze missionkeydes[] = 
{
   { VERSION_STRING, version_line_analyze, 0 },
   { DATE_STRING, date_line_analyze, 0 },
   { MEMBER_STRING, member_line_analyze, 0 },
   { 0, 0, 0 }
};

/* Used to analyze script lines */

/* mark begin of eventscript mask in localdes table */
#define EVENTSCRIPT_MASK_BEGIN 7 

struct local_line {
char    *keyword;
int     (*funct)();
int     index1;  
int     index2;  
} localdes[] = {
 { DATE_STRING,	     date_funct,   0,                     0 },
 { VERSION_STRING,   version_funct,0,                     0 },
 { MASTER_STRING,    script_funct, NOSUBSTITUTESCRIPT_INDEX,    0 },
 { SUBSTITUTE_STRING,     script_funct, NEWMASTERSCRIPT_INDEX,     0 },
 { SATELLITE_STRING, script_funct, SATELLITESCRIPT_INDEX, 0 },
 { EXCEPTION_STRING, script_funct, EXCEPTIONSCRIPT_INDEX, 0 },
 { EVENT_STRING,     script_funct, EVENTSCRIPT_INDEX,     0 },
 { NETWORK_UNKNOWN_TO_ON_STRING,  netmask_funct , UNKNOWN, ON },
 { NETWORK_UNKNOWN_TO_OFF_STRING, netmask_funct,  UNKNOWN, OFF },
 { NETWORK_ON_TO_OFF_STRING,      netmask_funct,  ON,      OFF },
 { NETWORK_ON_TO_UNKNOWN_STRING,  netmask_funct,  ON,      UNKNOWN },
 { NETWORK_OFF_TO_UNKNOWN_STRING, netmask_funct,  OFF,     UNKNOWN },
 { NETWORK_OFF_TO_ON_STRING,      netmask_funct,  OFF,     ON },
 { MEMBER_FAULT_TO_IDLE_STRING,      membmask_funct, FAULTY, IDLE },
 { MEMBER_FAULT_TO_MASTER_STRING,    membmask_funct, FAULTY, MASTERHOLDER },
 { MEMBER_FAULT_TO_SUBSTITUTE_STRING,     membmask_funct, FAULTY, SUBSTITUTE },
 { MEMBER_FAULT_TO_SATELLITE_STRING, membmask_funct, FAULTY, SATELLITE },
 { MEMBER_IDLE_TO_FAULT_STRING,      membmask_funct, IDLE, FAULTY },
 { MEMBER_IDLE_TO_MASTER_STRING,     membmask_funct, IDLE, MASTERHOLDER },
 { MEMBER_IDLE_TO_SUBSTITUTE_STRING,      membmask_funct, IDLE, SUBSTITUTE},
 { MEMBER_IDLE_TO_SATELLITE_STRING,  membmask_funct, IDLE, SATELLITE },
 { MEMBER_MASTER_TO_FAULT_STRING,    membmask_funct, MASTERHOLDER, FAULTY },
 { MEMBER_MASTER_TO_IDLE_STRING,     membmask_funct, MASTERHOLDER, IDLE },
 { MEMBER_MASTER_TO_SUBSTITUTE_STRING,    membmask_funct, MASTERHOLDER, SUBSTITUTE },
 { MEMBER_MASTER_TO_SATELLITE_STRING,membmask_funct, MASTERHOLDER, SATELLITE },
 { MEMBER_SUBSTITUTE_TO_FAULT_STRING,     membmask_funct, SUBSTITUTE, FAULTY },
 { MEMBER_SUBSTITUTE_TO_IDLE_STRING,      membmask_funct, SUBSTITUTE, IDLE },
 { MEMBER_SUBSTITUTE_TO_MASTER_STRING,    membmask_funct, SUBSTITUTE, MASTERHOLDER },
 { MEMBER_SUBSTITUTE_TO_SATELLITE_STRING, membmask_funct, SUBSTITUTE, SATELLITE },
 { MEMBER_SATELLITE_TO_FAULT_STRING, membmask_funct, SATELLITE, FAULTY },
 { MEMBER_SATELLITE_TO_IDLE_STRING,  membmask_funct, SATELLITE, IDLE },
 { MEMBER_SATELLITE_TO_MASTER_STRING,membmask_funct, SATELLITE, MASTERHOLDER },
 { MEMBER_SATELLITE_TO_SUBSTITUTE_STRING, membmask_funct, SATELLITE, SUBSTITUTE },
 { RESOURCE_UNKNOWN_TO_UNKNOWN_STRING,   resmask_funct, NOTKNOWN, NOTKNOWN },
 { RESOURCE_UNKNOWN_TO_FREE_STRING,      resmask_funct, NOTKNOWN, FREE },
 { RESOURCE_UNKNOWN_TO_RESERVED_STRING,  resmask_funct, NOTKNOWN, RESERVED },
 { RESOURCE_UNKNOWN_TO_MOUNTED_STRING,   resmask_funct, NOTKNOWN, MOUNTED },
 { RESOURCE_UNKNOWN_TO_FAULT_STRING,     resmask_funct, NOTKNOWN, FAULT },
 { RESOURCE_FREE_TO_UNKNOWN_STRING,      resmask_funct, FREE, NOTKNOWN },
 { RESOURCE_FREE_TO_FREE_STRING,         resmask_funct, FREE, FREE },
 { RESOURCE_FREE_TO_RESERVED_STRING,     resmask_funct, FREE, RESERVED },
 { RESOURCE_FREE_TO_MOUNTED_STRING,      resmask_funct, FREE, MOUNTED },
 { RESOURCE_FREE_TO_FAULT_STRING,        resmask_funct, FREE, FAULT },
 { RESOURCE_RESERVED_TO_UNKNOWN_STRING,  resmask_funct, RESERVED , NOTKNOWN },
 { RESOURCE_RESERVED_TO_FREE_STRING,     resmask_funct, RESERVED , FREE },
 { RESOURCE_RESERVED_TO_RESERVED_STRING, resmask_funct, RESERVED , RESERVED },
 { RESOURCE_RESERVED_TO_MOUNTED_STRING,  resmask_funct, RESERVED, MOUNTED },
 { RESOURCE_RESERVED_TO_FAULT_STRING,    resmask_funct, RESERVED, FAULT },
 { RESOURCE_MOUNTED_TO_UNKNOWN_STRING,   resmask_funct, MOUNTED, NOTKNOWN },
 { RESOURCE_MOUNTED_TO_FREE_STRING,      resmask_funct, MOUNTED, FREE },
 { RESOURCE_MOUNTED_TO_RESERVED_STRING,  resmask_funct, MOUNTED, RESERVED },
 { RESOURCE_MOUNTED_TO_MOUNTED_STRING,   resmask_funct, MOUNTED, MOUNTED },
 { RESOURCE_MOUNTED_TO_FAULT_STRING,     resmask_funct, MOUNTED, FAULT },
 { RESOURCE_FAULT_TO_UNKNOWN_STRING,     resmask_funct, FAULT, NOTKNOWN },
 { RESOURCE_FAULT_TO_FREE_STRING,        resmask_funct, FAULT, FREE },
 { RESOURCE_FAULT_TO_RESERVED_STRING,    resmask_funct, FAULT, RESERVED },
 { RESOURCE_FAULT_TO_MOUNTED_STRING,     resmask_funct, FAULT, MOUNTED },
 { RESOURCE_FAULT_TO_FAULT_STRING,       resmask_funct, FAULT, FAULT },
 { MISMATCH_STRING,			 mismask_funct, 0    , 0 },
 { 0, end_funct, 0, 0 },
 { 0, 0, 0, 0 }
};

/* Used to analyze member lines */
struct member_element {
int (*funct)();
} memberdes[MEMBER_COUNT_WORDS] = {
 { name_funct },
 { type_funct },
 { priority_funct },
 { broadcast_funct },
 { validity_funct },
 { redundancy_funct },
 { network1_funct },
 { network2_funct }
};

/* structure to analyze support lines */
struct support_line {
char *keyword;
int (*funct)();
} supportdes[] = {
 { LOG_FLAG_STRING, logflag_funct },
 { LOG_FILE_STRING, logfile_funct },
 { PRIORITY_STRING, os_priority_funct },
 { ACTIVITY_STRING, activity_funct },
 { PERIOD_STRING, period_funct },
 { THRESHOLD_STRING, threshold_funct },
/*
 { STATISTICS_STRING, statistics_funct },
*/
 { 0, end_funct },
 { 0, 0 }
};

#endif /* WDX_CONFIG_MODULE */

#endif /* WDX_CONFIG */
