/*
 *   WDX: WitchDoctor-WDX, versatile distributed lock manager
 *   Copyright (C) 2003 Dominique Chabord,
 *   Please refer to credits section below
 *
 *
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *   ************************************************
 *
 *   History and credits:
 *   First version of WitchDoctor-WDX was based on:
 *
 *   DECwatchdog/Autopilot, watchdog and lock manager
 *   Copyright (C) 2003 HP
 *
 *   Developed by
 *     Computer Special Systems, Annecy France
 *     A Division of Digital Equipment Corporation
 *   and
 *     Custom-Systems, Annecy France
 *     An engineering center of Compaq
 *
 *   Provided under GNU-GPL terms by HP, 30 June 2003
 *   GNU-GPL replaces previous license statements
 *
 *   Rebranded, ported and modified for Shaman-X project, 15 July 2003
 *   by Dominique Chabord
 *   and maintained by other contributors as mentionned in the code
 *
 *   ************************************************
 *
 *   WDX is promoted by Shaman-X project
 *
 *   Check for new versions and documentation at
 *   http://www.shaman-x.org
 *
 *   ************************************************
 *
 *   Most of WDX code is designed to run unchanged on
 *   different operating systems, including at V1.0 time:
 *   Gnu-Linux, WindowsNT, DigitalUNIX and OpenVMS.
 *   Operating system specifics are identified by dedicated files.
 *
 *   Evolutions
 *   ----------
 *   July-2003     Dominique Chabord    WitchDoctor-WDX V1.0
 *                 Creation
 *
 *   ************************************************
 *
 *   wdx_specific.h
 *
 *	C include files and specific definitions
 ************************************************************************/
/*
 *
 *  21-Apr-94 -- Cornu
 *      Creation
 * MK001  M. Kennealy    Added timers.h include file 
 */
#ifndef		WDX_SPECIFIC
#define		WDX_SPECIFIC


/*
 * OSF/1 include files
 */

#include        <unistd.h>
#include	<limits.h>
#include	<stdio.h>
#include	<errno.h>
#include	<string.h>
#include	<ctype.h>
/*-- delete LIONEL TRICON --*/
/*#include	<lmf.h>*/
/*-- fin delete LIONEL TRICON --*/
#include	<time.h>
#include	<syslog.h>
#include        <math.h>
#include        <stdarg.h>
#include        <netdb.h>
#include        <signal.h>
/*-- delete LIONEL TRICON --*/
/*#include        <timers.h>*/   /* MK001 */
/*-- fin delete LIONEL TRICON --*/
#include	<sys/types.h>
#include	<sys/param.h>
#include	<sys/stat.h>
#include	<sys/time.h>
#include	<sys/uio.h>
#include        <sys/dir.h>
/*-- delete LIONEL TRICON --*/
/*#include        <sys/lock.h>*/
/*-- fin delete LIONEL TRICON --*/
#include	<sys/file.h>
#include	<sys/resource.h>
#include	<sys/wait.h>
#include	<sys/ipc.h>
#include	<sys/mount.h>
#include	<sys/file.h>
#include        <netdb.h>
#include        <sys/socket.h>
#include        <sys/ioctl.h>
#include        <netinet/in.h>
#include        <net/if.h>
#include	<sys/timeb.h>

/*
 * Definitions
 */
#define DIRENTRY    dirent

#define PERM 0644	/* FIFO permission */

#define HIGHEST -20	/* OSF/1 highest process priority */

#define PRODUCT_MASTER_SUBSTITUTE "SHAMAN-X-WDX" /* master license name */

#define LOG0_FILE   "%s.0"	/* naming convention for renaming file */

#define MAXPROGPATHLEN 80

#ifdef DAEMON_DEBUG
#ifdef MAIN
char wdx_path[] = "./";		/* wdx path */
#else MAIN
extern char wdx_path[];
#endif MAIN

#else /*DAEMON_DEBUG*/
#ifdef MAIN

char wdx_path[MAXPROGPATHLEN + 1];
char wdx_path1[] = "/var/shaman-x/";					/* wdx path */
char wdx_path2[] = "/";									/* wdx path */

// char wdx_path[] = "/var/shaman-x/wdx/"; /* wdx path */

#else /*MAIN*/
extern char wdx_path[];
extern char wdx_path1[];
extern char wdx_path2[];
#endif
#endif /*DAEMON_DEBUG*/

typedef int WDX_SOCKET;
typedef int WDX_FIFO;

/*
#define WDX_FTIME(pt)	(ftime(pt))
*/
#define WDX_SLEEP(s)	(sleep(s))

#define SPECIFIC_SYNCHRO_WAIT 1

/* specific output messages */
#define ERROR_MESSAGE_SPECIFIC "ERROR   : "
#define WARNING_MESSAGE_SPECIFIC "WARNING : "
#define INFOR_MESSAGE_SPECIFIC "INFO    : "

#endif /*WDX_SPECIFIC*/
